;This file is copyright (c) 1992 Informant Communications Group and the
;article author. The material here may be used in an application provided
;that this copyright/disclaimer information is kept in the original source
;file. The material presented here is provided "as is" and with no guarantee.
;Informant Communications Group/Paradox Informant assume no responsibility
;for the use or misuse of the material contained within.
;
;Contents        : procedure RecMove,TKRecMove
;Source File     : RECMOVE.SC
;Author          : Justin Bunnell
;
;Informant Issue : March 1992
;
;Description     : A procedure that allows for custom cursor movement in 
;                  forms.
;
; Paradox Informant
; 8525 Elk Grove Blvd.
; Suite 126
; Elk Grove, CA  95624-1777
; Phone: (916) 686-6610
; Fax  : (916) 686-8497
; BBS  : (916) 686-4740


PROC Recmove( )

  Colnum = COLNO( )
  SWITCH
    CASE cmd = "Up"    : MOVETO FIELD Name[Mup[Colnum]]
    CASE cmd = "Down"  : MOVETO FIELD Name[Mdown[Colnum]]
    CASE cmd = "Left"  : MOVETO FIELD Name[Mleft[Colnum]] 
    CASE cmd = "Right" : MOVETO FIELD Name[Mright[Colnum]]
    CASE cmd = "Enter" : MOVETO FIELD Name[Menter[Colnum]]
  ENDSWITCH

ENDPROC

PROC TKRecmove( )

  PRIVATE Colnum
  Colnum = Colno( )
  SWITCH
    CASE TKChar = -72 :      ; UP
      MOVETO FIELD Name[Mup[COLNUM]]
    CASE TKChar = -80 :      ; DOWN
      MOVETO FIELD Name[Mdown[COLNUM]]
    CASE TKChar = -75 :      ; LEFT
      MOVETO FIELD Name[Mleft[COLNUM]]
    CASE TKChar = -77 :      ; RIGHT
      MOVETO FIELD Name[Mright[COLNUM]]
    CASE TKChar = 13 :      ; ENTER
      MOVETO FIELD Name[Menter[COLNUM]]
  ENDSWITCH
  Arrivefield( )

ENDPROC

;----------------------------------------------------------------------------

;PREPMOVE.SC

RESET
CLEAR

PAINTCANVAS FILL " " ATTRIBUTE 113 0,0,1,79
STYLE ATTRIBUTE 113
@ 0,0 ?? " Table:  "
@ 1,0 ?? " Enter the name of the Table you want to prepare or press <Enter> for a list "
@ 0,8 ACCEPT "A8" to Tbl

IF Tbl = "" then
   SHOWFILES NOEXT
   "*.db"
   " Highlight Table to Prepare"
   to Tbl
ENDIF
IF not Retval then RETURN "ESC Entered" ENDIF

PAINTCANVAS FILL " " ATTRIBUTE 113 0,0,1,79
@ 0,0  ?? "Form Number: "
@ 0,13 ACCEPT "N" to Formno

IF ISTABLE(Tbl) then
   COEDIT Tbl
   PICKFORM Formno
   Numfields = NFIELDS(tbl)+1
   ARRAY NAME[Numfields]
   CTRLEND
   Lastfield = COLNO()
   CTRLHOME

   WHILE COLNO() <> Lastfield
     Name[Colno()] = FIELD()
     ENTER
   ENDWHILE
   Name[Lastfield] = FIELD()

   Array Menter[Numfields]
   Array Mright[Numfields]
   Array Mleft[Numfields]
   Array Mup[Numfields]
   Array Mdown[Numfields]
   CTRLHOME
   WHILE COLNO() <> Lastfield
       Menter[COLNO()] = COLNO()
       Mright[COLNO()] = COLNO()
       Mleft[COLNO()] = COLNO()
       Mup[COLNO()] = COLNO()
       Mdown[COLNO()] = COLNO()
       ENTER
   ENDWHILE

   Menter[Lastfield] = Lastfield
   Mright[Lastfield] = Lastfield
   Mleft[Lastfield] = Lastfield
   Mup[Lastfield] = Lastfield
   Mdown[Lastfield] = Lastfield

ENDIF
Do_It!

SAVEVARS Menter, Mright, Mleft, Mup, Mdown, Name

; Rename SaveVars as Move Script
{Tools} {Rename} {Script} {savevars} {moves}

CLEARALL
RELEASE VARS Name, I, Numfields, Menter, Mright, Mleft, Mup, Mdown